<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */
$title="Status";
include ("prolog.php");
 
$spxNS = 'http://www.spinetix.com/namespace/1.0/spx';
$svgNS = 'http://www.w3.org/2000/svg';
$xlinkNS = 'http://www.w3.org/1999/xlink';

if ($product=="HMP100")
	echo "<img src='images/$productimage' width='550' height='323' alt='$vendor $product' usemap='#advancedMap'/>\n";
else
	echo "<img src='images/$productimage' width='550' height='323' alt='$vendor $product' />\n";
?>
<map id="advancedMap" name="advancedMap">
<area shape="circle" 
coords="433,126,7" 
alt="Advanced settings menu"
href="welcome.php?advanced=1" />
</map>
<?php

if ($safemode){
	print ("<h2 class='red'>Warning: The $product is running in Safe Mode</h2><br/><br/>");
}

if (preg_match("/Revision\W+:\s+(\w+)/",$cpuinfo,$match)){
	$val=hexdec($match[1]);
	$valc= floor($val/65536);
	$core = floor($valc/256).".".($valc % 256);
	$valc= $val % 65536;
	$carier = floor($valc/256).".".($valc % 256);
	$hwrdRevision= $core."/".$carier ;
}else
	$hwrdRevision="x.x/x.x";
print("<h2>Serial Number : $serialstring (rev. $hwrdRevision)</h2>\n");
?>
<table>
<?php


$ip_main = reset(get_ip_addrs());
if ($ip_main) {
    $ip_str = $ip_main[0] . " (" . ucfirst($ip_main[2]) . ")";
} else {
    $ip_str = "Not found";
}
$netconf = new ipconfig;
$netconf->load();

$config_name="/etc/raperca/spxconfig.xml";
//$config_name="../config.xml";
$spxconf=file_get_contents($config_name);
$deviceName="";
$screenId="";
if ($spxconf) {
	$domdoc = new DOMDocument;
	$domdoc->loadXML($spxconf);
	$multiscreen=$domdoc->getElementsByTagName("multiscreen");
	if ($multiscreen->length==1){
		$multiscreen=$multiscreen->item(0);
		if ($multiscreen->hasAttribute("screenId")) $screenId=$multiscreen->getAttribute("screenId");
	}
	$reporting=$domdoc->getElementsByTagName("reporting");
	if ($reporting->length==1){
		$reporting=$reporting->item(0);
		if ($reporting->hasAttribute("deviceName")) $deviceName=$reporting->getAttribute("deviceName");
	}
}
if ($deviceName=="") $deviceName=$serial;
if ($screenId=="") $screenId=$serial;

// firmware
$release = file_get_contents('/etc/spinetix-release');
$vals=explode(" ", $release);
$firmware="error";
$build="error";
if (count($vals)==6 ){
	$firmware = $vals[3];
	$build = $vals[5];
}
echo "<tr><td>Firmware : </td><td>", htmlspecialchars($firmware), "</td></tr>";
echo "<tr><td>IP : </td><td>", htmlspecialchars($ip_str), "</td></tr>";
echo "<tr><td>MAC : </td><td>", htmlspecialchars(getMAC()), "</td></tr>";
echo "<tr><td>Device name : </td><td>", htmlspecialchars($deviceName), "</td></tr>";
echo "<tr><td>Multiscreen ID : </td><td>", htmlspecialchars($screenId), "</td></tr>";

?> 
</table>

<?php
$modempresent = (file_exists('/dev/modem') && file_exists('/dev/.modem-data/status'));
if ($netconf->netiface == ipconfig::NET_MODEM || $modempresent) {
    echo "<h2>3G Modem</h2>\n";
    echo "<table>\n";
    echo "<tr><td>Status: </td><td>";
    if ($modempresent) {
        switch (trim(file_get_contents('/dev/.modem-data/status'))) {
        case 'READY':
            if (file_exists('/dev/.modem-data/connect-status')) {
                switch (trim(file_get_contents('/dev/.modem-data/connect-status'))) {
                case 'ONLINE':
                    echo "online"; break;
                case 'CONNECTING':
                    echo "connecting"; break;
                case 'CONNECTED':
                    echo "connected, initializing link"; break;
                case 'DISCONNECTED':
                    echo "disconnected"; break;
                case 'IO ERROR':
                    echo "I/O error while connecting"; break;
                case 'TIMEOUT':
                    echo "bad command or timeout"; break;
                case 'NETWORK ERROR':
                    echo "phone network error"; break;
                default:
                    echo "ready, unknown connection status"; break;
                }
            } else {
                echo "ready";
            }
            break;
        case 'PIN INCORRECT':
            echo "locked, PIN is incorrect"; break;
        case 'PIN':
            echo "locked, PIN required"; break;
        case 'PUK INCORRECT':
            echo "locked, PUK is incorrect"; break;
        case 'PUK':
            echo "locked, PUK required"; break;
        case 'PIN2':
            echo "locked, PIN2 required"; break;
        case 'PUK2':
            echo "locked, PUK2 required"; break;
        case 'ERROR':
            echo "initialization failed"; break;
        default:
            echo "unknown state"; break;
        }
    } else {
        echo "not found";
    }
    echo "</td></tr>\n";
    echo "<tr><td>Signal quality: </td><td>";
    $sq = modemconfig::getSignalQuality();
    if ($sq === false)
        echo "<i>unknown</i>";
    else
        echo htmlspecialchars($sq), "&nbsp;%";
    echo "</td></tr>\n";
    echo "<tr><td>Device: </td><td>";
    if ($modempresent && file_exists('/dev/.modem-data/manufacturer'))
        echo " " . htmlspecialchars(trim(file_get_contents('/dev/.modem-data/manufacturer')));
    if ($modempresent && file_exists('/dev/.modem-data/model'))
        echo " " . htmlspecialchars(trim(file_get_contents('/dev/.modem-data/model')));
    if ($modempresent && file_exists('/dev/.modem-data/revision'))
        echo " (rev. " . htmlspecialchars(trim(file_get_contents('/dev/.modem-data/revision'))) . ")";
    if (!$modempresent)
        echo "<i>unknown</i>";
    echo "</td></tr>\n";
    echo "<tr><td>Serial # (IMEI): </td><td>";
    if ($modempresent && file_exists('/dev/.modem-data/serial'))
        echo " " . htmlspecialchars(file_get_contents('/dev/.modem-data/serial'));
    else
        echo "<i>unknown</i>";
    echo "</td></tr>\n";
    echo "<tr><td>Mobile Subscriber ID : </td><td>";
    if ($modempresent && file_exists('/dev/.modem-data/imsi'))
        echo " " . htmlspecialchars(file_get_contents('/dev/.modem-data/imsi'));
    else
        echo "<i>unknown</i>";
    echo "</td></tr>\n";
    echo "</table>\n";
}

$bufr = file_get_contents('/proc/bus/usb/devices');

$bufe = explode("\n", $bufr);
$usbList=array();
$devnum = 0;
foreach( $bufe as $buf ) {
	if (preg_match('/^T/', $buf)) {
    	$devnum += 1;
	    $usbList[$devnum] = "";
	} elseif (preg_match('/^S:/', $buf)) {
    	list($key, $value) = split(': ', $buf, 2);
    	list($key, $value2) = split('=', $value, 2);
	    if (trim($key) != "SerialNumber" && trim($key) != "Manufacturer") {
    		$usbList[$devnum] .= " " . trim($value2);
		}
    } 
}

$hasUSB=false;
foreach ($usbList as $usbname){
	$usb=preg_replace("/USB/i",'',$usbname);
	if (!strpos($usb,"Hub") && !strpos($usb,"EHCI") && !strpos($usb,"UHCI") && strlen($usb)>1){ // do not print the hubs
		if (!$hasUSB){
			echo "<h2>USB Devices: </h2>\n<table>\n";
			$hasUSB=true;
		} 
		print("<tr><td>". htmlspecialchars($usb). "</td></tr>");
	}
}
if ($hasUSB) echo "</table>";

?>

<?php
include ("final.php");
?>
