<?php

class LogsInfo extends CModel {
	
	var $accounting= array();
    var $current= array();
    var $backup= array();
    var $streaming= array();
    var $base="log/";
    
    
    public function attributeNames() {
        return array("accounting", "current", "backup", "streaming" );
    }
    public function safeAttributes() {
        return array();
    }
    public function load() {
        $logPath='/srv/raperca/log';
        //if (!file_exists('/srv/raperca/log/') )return;
        $filelist=scandir($logPath);
        natsort($filelist);
        if ( in_array("accounting.log", $filelist ) )
            $this->accounting[] = "accounting.log";
        
        foreach($filelist as $file){
            if ($file[0]=='.') continue;
            if ( strcmp($file,"accounting.log")==0 ) continue;
            if (strncmp($file,"accounting",10)==0 )
                $this->accounting[] = $file; 
            else if (strncmp(substr($file,-3),".gz",3)==0)
                $this->backup[] = $file; 
            else
                $this->current[] = $file; 
        }
        
        $streamPath='/srv/raperca/capture';
        if ( file_exists($streamPath) ) {
            $filelist=scandir($streamPath);
            foreach($filelist as $file){
                if ($file[0]=='.') continue;
                $this->streaming[] = $file; 
            }
        }
    }
}