
<?php 

echo CHtml::tag("h2", array(), "Display Settings") ."\n";

//echo CHtml::errorSummary( $screen )  ."\n";
echo CHtml::errorSummary( $config )  ."\n";

echo CHtml::openTag("div", array("class"=>"yiiForm") );
echo CHtml::form();

echo "<table>\n";

echo "<tr><td/><td/><td rowspan='11' valign='middle' align='center' width='340'>\n";

echo "<img id='ScreenImg' src='images/screen_4_3.png' alt='Script error' />";
echo "<br/>\n";

echo CHtml::activeCheckBox($screen, "forcear", array('id'=>'ForceARCheck', 'onclick'=>'forceAspect()'));
echo CHtml::activeLabel($screen, "forcear"). " ";
$options = array('id'=>'ARSelect', 'onchange'=>'updateAR("",false)' );
if ( !$screen->forcear )
    $options['disabled']='disabled';
echo CHtml::activeDropDownList( $screen, "screeenar", $screen->default_mon_ar, $options );
echo "<br/><br/>\n";

echo CHtml::activeLabel($config, "orientation")." ";
echo CHtml::activeDropDownList($config, "orientation", $config->orientationsList, array('id'=>'DirSelect', 'onchange'=>'updateImage()'));
echo "<br/>\n"; 

echo "</td></tr>";

foreach ($screen->presets as $id => $values){
	if (is_array($values)){
	    echo "<tr><td>";
        $options = array( 'value'=>"$id", 'onclick'=>'updateAR("'.$values[3].'", true)', 'uncheckValue'=>null );
        echo Chtml::activeRadioButton($screen, "simpledisplay", $options ) ;
        echo CHtml::encode($values[4]);
        echo "</td><td>". CHtml::encode($values[5]);
        echo "</td></tr>\n";
	}else{
	    echo "<tr><td colspan='2'><h3>". CHtml::encode($values). "</h3></td></tr>\n";
	}
}

echo "</table>\n";


echo CHtml::activeCheckBox($config, "audio")." ";
echo CHtml::activeLabel($config, "audio");

echo CHtml::activeHiddenField($screen, "dcoffsetsupp")."\n";

echo CHtml::openTag("div", array( 'class'=>'action') );
echo CHtml::submitButton("Apply", array('name'=>'simple') );
echo CHtml::closeTag("div" );

echo CHtml::endForm();
echo CHtml::closeTag("div" );

?>
<script type="text/javascript">
<!--
<?php
echo "var defaultAR=\"{$screen->screeenar}\";\n";
?>


function forceAspect()
{
	var selectAr=document.getElementById("ARSelect");
	var checkAr=document.getElementById("ForceARCheck");
	selectAr.disabled=!checkAr.checked;
	updateAR(defaultAR, false);
}
function updateImage()
{
	var dirNames=new Array("", "_90CW", "_90CCW", "_180", "_V", "_H");
	var arNames=new Array("4_3", "16_9", "16_10");
	var arNames2=new Array("4:3", "16:9", "16:10");
	var selectOrientation=document.getElementById("DirSelect");
	var selectAR=document.getElementById("ARSelect");
	var imgAr=document.getElementById("ScreenImg");
	
	imgAr.alt="Screen "+ arNames2[selectAR.selectedIndex];
	
	imgAr.src="images/screen_"+ arNames[selectAR.selectedIndex] + dirNames[selectOrientation.selectedIndex] + ".png";
	
}
function updateAR(strAspectRatio, boolForce)
{
	
	var checkAr=document.getElementById("ForceARCheck");
	var selectAr=document.getElementById("ARSelect");
	
	if (boolForce){
		checkAr.checked=false;
		selectAr.disabled=true;
	}
	
	var x=selectAr.selectedIndex;
	if (strAspectRatio=="") {
		if (selectAr.selectedIndex==0){
			strAspectRatio="4:3";
		} else if (selectAr.selectedIndex==1){
			strAspectRatio="16:9";
		} else {
			strAspectRatio="16:10";
		}
	} else {
		defaultAR=strAspectRatio;	
	}
	if (!checkAr.checked){
		if (strAspectRatio=="4:3"){
			selectAr.selectedIndex=0;
		} else if (strAspectRatio=="16:9"){
			selectAr.selectedIndex=1;
		} else if (strAspectRatio=="16:10"){
			selectAr.selectedIndex=2;
		}
	}
	updateImage();
	
	
}

// make sure the right image is being displayed
updateImage();
-->
</script>
