<?php 

if ($security->needreload) {
    echo "<h2>Status</h2>\n";
    echo "<p>The security change will be effective in a few seconds.</p>\n";
}


echo CHtml::errorSummary( $security )  ."\n";

echo CHtml::tag("h2", array(), "Administrative Server") ."\n";

echo CHtml::openTag("div", array("class"=>"yiiForm") );
echo CHtml::form();

if (!$security->protectedAdmin) {
    echo "<p style='color: red'><strong>Warning:</strong> Administrative area is not password protected.<br/></p>\n";
}

echo CHtml::hiddenField("scenario", "admin" );

echo CHtml::errorSummary( $security->admin )  ."\n";

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->admin, "username");
echo CHtml::activeHiddenField($security->admin, "username", array('value'=>'admin') );
echo CHtml::activeTextField($security->admin, "username", array('disabled'=>'disabled', 'value'=>'admin') );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->admin, "old_pass");
echo CHtml::activePasswordField($security->admin, "old_pass" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->admin, "new_pass");
echo CHtml::activePasswordField($security->admin, "new_pass" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->admin, "new_pass2");
echo CHtml::activePasswordField($security->admin, "new_pass2" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array( 'class'=>'action') );
echo CHtml::submitButton("Apply", array('name'=>'security') );
echo CHtml::closeTag("div");

echo CHtml::endForm();
echo CHtml::closeTag("div");





echo CHtml::tag("h2", array(), "Content Server") ."\n";

echo CHtml::openTag("div", array("class"=>"yiiForm") );
echo CHtml::form();

echo CHtml::hiddenField("scenario", "content" );

echo CHtml::errorSummary( $security->content )  ."\n";

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security, "protectedContent");
echo CHtml::activeRadioButton($security, "protectedContent", array('value'=>'1', 'uncheckValue'=>null) ). " yes";
echo CHtml::activeRadioButton($security, "protectedContent", array('value'=>'0', 'uncheckValue'=>null) ). " no";
echo CHtml::closeTag("div");


echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->content, "username");
echo CHtml::activeHiddenField($security->content, "username", array('value'=>'content') );
echo CHtml::activeTextField($security->content, "username", array('disabled'=>'disabled', 'value'=>'content') );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->content, "new_pass");
echo CHtml::activePasswordField($security->content, "new_pass" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->content, "new_pass2");
echo CHtml::activePasswordField($security->content, "new_pass2" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array( 'class'=>'action') );
echo CHtml::submitButton("Apply", array('name'=>'security') );
echo CHtml::closeTag("div");

echo CHtml::endForm();
echo CHtml::closeTag("div");



echo CHtml::tag("h2", array(), "Monitoring") ."\n";

echo CHtml::openTag("div", array("class"=>"yiiForm") );
echo CHtml::form();

echo CHtml::hiddenField("scenario", "monitoring" );

echo CHtml::errorSummary( $security->monitoring )  ."\n";

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security, "protectedMonitoring");
echo CHtml::activeRadioButton($security, "protectedMonitoring", array('value'=>'1', 'uncheckValue'=>null) ). " yes";
echo CHtml::activeRadioButton($security, "protectedMonitoring", array('value'=>'0', 'uncheckValue'=>null) ). " no";
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->monitoring, "username");
echo CHtml::activeHiddenField($security->monitoring, "username", array('value'=>'monitoring') );
echo CHtml::activeTextField($security->monitoring, "username", array('disabled'=>'disabled', 'value'=>'monitoring') );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->monitoring, "new_pass");
echo CHtml::activePasswordField($security->monitoring, "new_pass" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array("class"=>"simple") );
echo CHtml::activeLabel($security->monitoring, "new_pass2");
echo CHtml::activePasswordField($security->monitoring, "new_pass2" );
echo CHtml::closeTag("div");

echo CHtml::openTag("div", array( 'class'=>'action') );
echo CHtml::submitButton("Apply", array('name'=>'security') );
echo CHtml::closeTag("div");

echo CHtml::endForm();
echo CHtml::closeTag("div");
